package com.fs.course.service;

import java.util.List;
import com.baomidou.mybatisplus.extension.service.IService;
import com.fs.common.core.domain.R;
import com.fs.course.domain.FsUserCoursePeriodDays;
import com.fs.course.param.CompanyRedPacketParam;
import com.fs.course.param.PeriodRedPacketParam;

/**
 * 营期课程Service接口
 *
 * @author fs
 * @date 2025-04-16
 */
public interface IFsUserCoursePeriodDaysService extends IService<FsUserCoursePeriodDays>{
    /**
     * 查询营期课程
     *
     * @param id 营期课程主键
     * @return 营期课程
     */
    FsUserCoursePeriodDays selectFsUserCoursePeriodDaysById(Long id);

    /**
     * 查询营期课程列表
     *
     * @param fsUserCoursePeriodDays 营期课程
     * @return 营期课程集合
     */
    List<FsUserCoursePeriodDays> selectFsUserCoursePeriodDaysList(FsUserCoursePeriodDays fsUserCoursePeriodDays);

    /**
     * 新增营期课程
     *
     * @param fsUserCoursePeriodDays 营期课程
     * @return 结果
     */
    int insertFsUserCoursePeriodDays(FsUserCoursePeriodDays fsUserCoursePeriodDays);

    /**
     * 修改营期课程
     *
     * @param fsUserCoursePeriodDays 营期课程
     * @return 结果
     */
    int updateFsUserCoursePeriodDays(FsUserCoursePeriodDays fsUserCoursePeriodDays);

    /**
     * 批量删除营期课程
     *
     * @param ids 需要删除的营期课程主键集合
     * @return 结果
     */
    int deleteFsUserCoursePeriodDaysByIds(Long[] ids);

    /**
     * 删除营期课程信息
     *
     * @param id 营期课程主键
     * @return 结果
     */
    int deleteFsUserCoursePeriodDaysById(Long id);

    R addCourse(FsUserCoursePeriodDays entity);

    R updateListCourseData(List<FsUserCoursePeriodDays> entity);

    /**
     * 根据营期id获取关联的公司
     * @param periodId 营期id
     * @param videoId 视频id
     * @return
     */
    List<CompanyRedPacketParam> getCompanyByPeriod(Long periodId, Long videoId);

    /**
     *
     * @param periodId 营期id
     * @param companyId 公司id
     * @return
     */
    List<PeriodRedPacketParam> getPeriodRedPacketList(Long periodId, Long companyId);
}
